commit 2a87c1fb9d76cd00cc1815c9b56b8bea47e409e1
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Nov 30 19:41:43 2025 +0000

    perl-spf: fix undef whine

diff --git a/src/src/miscmods/perl.c b/src/src/miscmods/perl.c
index 41d946735..1b111e711 100644
--- a/src/src/miscmods/perl.c
+++ b/src/src/miscmods/perl.c
@@ -77,6 +77,7 @@ if (SvTRUE(ERRSV))
   STRLEN len;
   s = US SvPV(ERRSV, len);
   s = string_copyn(s, (unsigned)len);
+  debug_printf_indent("adding perl codeblock: %s\n", s);
   }
 
 setlocale(LC_ALL, "C");		/* In case it got changed */
@@ -228,9 +229,13 @@ errstr = exim_perl_add_codeblock(US
 	/*XXX only one rrtype per query...*/
 	"my $rrtype = $rr->{$rrtype_str};"
         "my $dnsa = Exim::dns_lookup($dom, $rrtype);"
+
 	"my $res;"
-	"my $res = Net::DNS::Packet->decode(\\$dnsa) unless (!defined($dnsa));"
-		/* "Exim::debug_write( $res->string . '\n' );" */
+	"$res = new Net::DNS::Packet(\\$dnsa) if (defined($dnsa));"
+
+	/*XXX dumb, but at least clears the undef on errorstring */
+	"$self->errorstring(defined($dnsa) ? 'ok' : 'timeout');"
+
 	"return $res;"
   "}"
   "package MAIN;"
diff --git a/src/src/miscmods/spf_perl.c b/src/src/miscmods/spf_perl.c
index 17eb3ce35..4e854d7af 100644
--- a/src/src/miscmods/spf_perl.c
+++ b/src/src/miscmods/spf_perl.c
@@ -61,9 +61,10 @@ static const uschar spf_pl[] =
   "use Mail::SPF;"
   "sub my_spf_req {"
     "my ($mfrom, $conn_addr, $conn_helo) = @_;"
+    "my ($id, $sc) = ($mfrom ne '') ? ($mfrom, 'mfrom') : ($conn_helo, 'helo');"
     "my $request = Mail::SPF::Request->new("
-      "scope       => 'mfrom',"
-      "identity    => $mfrom,"
+      "scope       => $sc,"
+      "identity    => $id,"
       "ip_address  => $conn_addr,"
       "helo_identity => $conn_helo"
       ");"
@@ -80,21 +81,19 @@ spf lookup routine to it.  Safely does nothing if called again.
 */
 
 static const misc_module_info *
-setup_spf_perl_mi(void)
+setup_spf_perl_mi(uschar ** errstr)
 {
 typedef uschar * (*fn_t)(const uschar *);
 
 if (!spf_perl_mi)
   {
   if (!(spf_perl_mi = perl_startup(opt_perl_startup ? opt_perl_startup : US"")))
-    /* errstr = string_sprintf("spf: %s", expand_string_message); */
+    {
+    *errstr = string_sprintf("spf: %s", expand_string_message);
     return NULL;
+    }
 
-  /*XXX could return an error string here:
-  if ((errstr = (((fn_t *) spf_perl_mi->functions)[PERL_ADDBLOCK]) (spf_pl)))
-  */
-
-  if ((((fn_t *) spf_perl_mi->functions)[PERL_ADDBLOCK]) (spf_pl))
+  if ((*errstr = (((fn_t *) spf_perl_mi->functions)[PERL_ADDBLOCK]) (spf_pl)))
     return spf_perl_mi = NULL;
   }
 return spf_perl_mi;
@@ -187,14 +186,18 @@ spf_process(const uschar ** listptr, const uschar * spf_envelope_sender,
   int action)
 {
 int res = FAIL, sep;
+uschar * errstr;
 const uschar * arglist = *listptr;
 
 expand_level++;
 DEBUG(D_acl)
   debug_printf_indent("%s: mfrom:<%s>\n", __FUNCTION__, spf_envelope_sender);
 
-if (!setup_spf_perl_mi())
+if (!setup_spf_perl_mi(&errstr))
+  {
+  expand_level--;
   return FAIL;
+  }
 
 if (!(conn_helo && conn_addr))
   spf_result = US"permerror";
@@ -327,13 +330,14 @@ spf_lookup_find(void * handle, const uschar * filename,
   const uschar * keystring, int key_len, uschar ** result, uschar ** errmsg,
   uint * do_cache, const uschar * opts)
 {
+uschar * errstr;
 int res = FAIL;
 
 DEBUG(D_acl) debug_printf_indent("%s: mfrom:<%s> ip %q\n", __FUNCTION__,
 				  keystring, filename);
 expand_level++;
 
-if (setup_spf_perl_mi())
+if (setup_spf_perl_mi(&errstr))
   if (!filename)
     *result = US"permerror";
   else

